#include "SPI.h"
#include "Arduino.h"
#include "pins_arduino.h"


#ifdef __cplusplus
extern "C"{
#endif

#ifdef __ARDUINO__
#include <wiring.h>
#endif

void spi_begin()//setup_spi
{

  SPCR |= _BV(MSTR);
  SPCR |= _BV(SPE);

  pinMode(SCK, OUTPUT);
  pinMode(MOSI, OUTPUT);
	
  
}

void spi_end()
{
  SPCR &= ~_BV(SPE);
}

uint8_t spi_transfer(uint8_t out)
{
  SPDR = out;
  while (!(SPSR & _BV(SPIF)));
  return SPDR;
}



void spi_setBitOrder(uint8_t bitOrder)
{
  if(bitOrder == LSBFIRST) {
    SPCR |= _BV(DORD);
  } else {
    SPCR &= ~(_BV(DORD));
  }
}

void spi_setDataMode(uint8_t mode)
{
  SPCR = (SPCR & ~SPI_MODE_MASK) | mode;
}

void spi_setClockDivider(uint8_t rate)
{
  SPCR = (SPCR & ~SPI_CLOCK_MASK) | (rate & SPI_CLOCK_MASK);
  SPSR = (SPSR & ~SPI_2XCLOCK_MASK) | ((rate >> 2) & SPI_2XCLOCK_MASK);
}


