#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdlib.h>
#include <stdio.h>
#include <util/delay.h>
#include "uart.h"



void ad_init(unsigned char channel)   
{   
  ADCSRA|=(1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0);   
  ADMUX|=(1<<REFS0)|(1<<ADLAR);
  ADMUX=(ADMUX&0xf0)|channel;   
  ADCSRA|=(1<<ADEN);
}   

unsigned int ad_sample(void){
ADCSRA|=(1<<ADSC);
while(bit_is_set(ADCSRA, ADSC));
return ADCH;
}

void init_serial(int speed)
{
  /* Set baud rate */
  UBRR0 = CPU_FREQ/(((unsigned long int)speed)<<4)-1;

  /* Enable transmitter & receiver */
  UCSR0B = (1<<TXEN0 | 1<<RXEN0);

  /* Set 8 bits character and 1 stop bit */
  UCSR0C = (1<<UCSZ01 | 1<<UCSZ00);

  /* Set off UART baud doubler */
//  UCSR0A &= ~(1 << U2X0);
}



unsigned char get_serial(void) {
  loop_until_bit_is_set(UCSR0A, RXC0);
  return UDR0;
}




void uputchar( char c )
{
  loop_until_bit_is_set(UCSR0A, UDRE0);
  UDR0 = c;
  while(get_serial()!='0') {}
}


void uputs( char *s )
{
  while( *s )
    uputchar( *s++ );
  //uputchar(13);
}


void uputsnl( char *s )
{
  uputs( s );
  uputchar( 0x0A );
}

void println(char* s) {
	uputsnl(s);
}

void print(char* s) {
uputs(s);
}

void printchar(char s) {
uputchar(s);
}

void print_int(int d) {
char s[30];
	sprintf(s,"%d",d);
	println(s);
}
